import numpy as np

D = np.loadtxt( "datos.txt" )
# print( D.shape )

#
np.random.seed(3)

eta = 0.05

#  Para cada neurona es un vector [w1, w2, 1]^T
# P1 = 0.02*np.random.randn( 3, 2 )   # Dos neuronas de entrada
# P2 = 0.02*np.random.randn( 3, 2 )   # Dos neuronas de salida

# P1 = np.zeros( (3, 2) )   # Dos neuronas de entrada
# P2 = np.zeros( (3, 2) )   # Dos neuronas de salida

# Los pesos del ejemplo del libro de Gonzalez y Woods:
# P1 = np.array( [ [ 4.792, 4.792 ],
#                    [ 4.486, 4.486 ],
#                  [ 4.590,-4.486 ] ] )
 
#P2 = np.array( [ [ -9.180, 9.429 ],
#                  [  9.178, -9.427 ],
#                  [  4.420, -4.419 ] ] )



P1 = np.array( [ [ 1.0, 1.0 ],
                 [ 1.0, 1.0 ],
                 [ 1.0,-1.0 ] ] )
 
P2 = np.array( [ [ -2.0,  2.0 ],
                 [  2.0, -2.0 ],
                 [  2.0, -2.0 ] ] )

P1 = np.array( [[ 0.98323714,  0.97655042],
                [ 0.92747822,  0.93357721],
                [ 1.1165848 , -1.14047576]] )

P2 = np.array( [[-4.55373835,  4.55373835],
                [ 4.56746234, -4.56746234],
                [ 1.70888905, -1.70888905]] )

# Para guardar 
Z1 = np.zeros( (1,2) )
A1 = np.zeros( (1,3) )
Delta1 = np.zeros( (2,1) )

Z2 = np.zeros( (1,2) )
A2 = np.zeros( (1,2) )
Delta2 = np.zeros( (2,1) )

vv = np.zeros( (1,3) )

def sigmoide( x ) :
	return 1.0/(1.0+np.exp(-x))

# La entrada debe ser un vector de tamaño (1,3)
# el último debe ser igual a 1 (para representar el sesgo)
def hacia_adelante( Entradas ) : 

	# Realizamos los cálculos en la primera capa
	#      1x3      3x2 = 1x2   
	Z1 = Entradas @ P1 

	A1[0,0:2] = sigmoide( Z1 )
	A1[0,2] = 1.0

	###########################
	#    1x3  3x2  = 1x2
	Z2 = A1 @ P2 
	A2[0,0:2] = sigmoide( Z2 )

	return A2[0,0], A2[0,1]

def calcula_deltas( tk1, tk2 ) :
	# A la salida :
	# El signo del error ya es negativo aquí
	# y las sumas son positivas en el descenso_gradiente()
	#
	Delta2[0,0] = sigmoide(Z2[0,0])*(1.0 - sigmoide(Z2[0,0]))*(tk1 - A2[0,0])
	Delta2[1,0] = sigmoide(Z2[0,1])*(1.0 - sigmoide(Z2[0,1]))*(tk2 - A2[0,1])

	Delta1[0,0] = sigmoide(Z1[0,0])*(1.0 - sigmoide(Z1[0,0]))*(Delta2[0,0]*P2[0,0] + Delta2[1,0]*P2[0,1])
	Delta1[1,0] = sigmoide(Z1[0,1])*(1.0 - sigmoide(Z1[0,1]))*(Delta2[0,0]*P2[1,0] + Delta2[1,0]*P2[1,1])

def descenso_gradiente( a ) :
	P1[0,0] += eta * a[0,0] * Delta1[0,0] 
	P1[1,0] += eta * a[0,1] * Delta1[0,0] 
	P1[2,0] += eta * Delta1[0,0] 

	P1[0,1] += eta * a[0,0] * Delta1[1,0] 
	P1[1,1] += eta * a[0,1] * Delta1[1,0] 
	P1[2,1] += eta * Delta1[1,0] 

	P2[0,0] += eta * A1[0,0] * Delta2[0,0] 
	P2[1,0] += eta * A1[0,1] * Delta2[0,0] 
	P2[2,0] += eta * Delta2[0,0] 

	P2[0,1] += eta * A1[0,0] * Delta2[1,0] 
	P2[1,1] += eta * A1[0,1] * Delta2[1,0] 
	P2[2,1] += eta * Delta2[1,0] 

def calcula_error( ) :
	error = 0.0

	j = 0
	while j < 4 :
		vv[0,:] = [ D[j,0], D[j,1], 1.0 ]
		s1, s2 = hacia_adelante( vv )
		k1 = D[j,2] - A2[0,0] 
		k2 = D[j,3] - A2[0,1]
		# print( "ks:", k1, k2 ) 
		error += k1*k1 + k2*k2
		j += 1
	
	return np.sqrt(error/8)

def calcula_error_dos( ) :
	error = 0.0

	j = 0
	while j < 4 :
		vv[0,:] = [ D[j,0], D[j,1], 1.0 ]
		s = hacia_adelante( vv )
		k = s-D[j,2]
		print( D[j,0], D[j,1], s )
		error += k*k
		j += 1
	
	return np.sqrt(error/4)

# Entrenamiendo

error = calcula_error( )
print( 0, error )

# print( P1 )
# print( P2 )

i= 1
k = 0
while i<1000 :
	j = 0
	# muestra = np.random.permutation( 4 )
	while j < 4 :
		# vv[0,:] = [ D[muestra[j],0], D[muestra[j],1], 1.0 ]
		vv[0,:] = [ D[j,0], D[j,1], 1.0 ]
		hacia_adelante( vv ) 
		# calcula_deltas( D[muestra[j],2], D[muestra[j],3] )
		calcula_deltas( D[j,2], D[j,3] )
		descenso_gradiente( vv )
		j += 1

	error = calcula_error( )
	print( i, error )
	i += 1

print( P1 )
print( P2 )
# calcula_error_dos( )
